package com.jpsoft.smart.modules.business.service.impl;

import java.math.BigDecimal;
import java.util.*;
import javax.annotation.Resource;

import com.jpsoft.smart.modules.base.entity.PersonInfo;
import com.jpsoft.smart.modules.business.dao.FillAttendanceDAO;
import com.jpsoft.smart.modules.business.dao.FillAttendanceFilesDAO;
import com.jpsoft.smart.modules.business.dao.WorkAttendanceDAO;
import com.jpsoft.smart.modules.business.entity.FillAttendance;
import com.jpsoft.smart.modules.business.entity.FillAttendanceFiles;
import com.jpsoft.smart.modules.business.entity.WorkAttendance;
import com.jpsoft.smart.modules.business.service.FillAttendanceService;
import com.jpsoft.smart.modules.common.utils.StringUtils;
import org.springframework.stereotype.Component;
import org.springframework.transaction.annotation.Transactional;
import com.github.pagehelper.Page;
import com.jpsoft.smart.modules.common.dto.Sort;
import com.github.pagehelper.PageHelper;

@Transactional
@Component(value = "fillAttendanceService")
public class FillAttendanceServiceImpl implements FillAttendanceService {
    @Resource(name = "fillAttendanceDAO")
    private FillAttendanceDAO fillAttendanceDAO;

	@Resource(name = "workAttendanceDAO")
	private WorkAttendanceDAO workAttendanceDAO;

	@Resource(name = "fillAttendanceFilesDAO")
	private FillAttendanceFilesDAO fillAttendanceFilesDAO;

    @Override
    public FillAttendance get(String id) {
        // TODO Auto-generated method stub
        return fillAttendanceDAO.get(id);
    }

    @Override
    public int insert(FillAttendance model) {
        // TODO Auto-generated method stub
        //model.setId(UUID.randomUUID().toString());

        return fillAttendanceDAO.insert(model);
    }

    @Override
    public int update(FillAttendance model) {
        // TODO Auto-generated method stub
        return fillAttendanceDAO.update(model);
    }

    @Override
    public int delete(String id) {
        // TODO Auto-generated method stub
        return fillAttendanceDAO.delete(id);
    }

    @Override
    public boolean exist(String id) {
        // TODO Auto-generated method stub
        int count = fillAttendanceDAO.exist(id);

        return count > 0 ? true : false;
    }

    @Override
    public List<FillAttendance> list() {
        // TODO Auto-generated method stub
        return fillAttendanceDAO.list();
    }

    @Override
    public Page<FillAttendance> pageSearch(Map<String, Object> searchParams, int pageNumber, int pageSize, List<Sort> sortList) {
        Page<FillAttendance> page = PageHelper.startPage(pageNumber, pageSize).doSelectPage(() -> {
            fillAttendanceDAO.search(searchParams, sortList);
        });

        return page;
    }

    @Override
    public FillAttendance insertAndfile(String workAttendanceId, String workAttendanceDate, String workAttendanceTime, String content, String type, String photoFile, String approvalPersonId,Long personId,String alarmConfigId) throws Exception{
        if (StringUtils.isBlank(workAttendanceId)) {
            //无考勤记录则为外勤打卡
			WorkAttendance workAttendance = new WorkAttendance();
			workAttendance.setId(UUID.randomUUID().toString());
			workAttendance.setAlarmConfigId(alarmConfigId);
			workAttendance.setPersonId(personId);
			workAttendance.setResult("0");
			workAttendance.setTemperature(BigDecimal.ZERO);
			workAttendance.setRecordTime(new Date());
			workAttendance.setCreateTime(new Date());
			workAttendance.setDelFlag(false);
			workAttendance.setSources("2");
			workAttendanceDAO.insert(workAttendance);
			workAttendanceId = workAttendance.getId();



        }
        //新增外勤打卡、补卡申请记录
        FillAttendance fillAttendance0 = fillAttendanceDAO.findByBusinessWorkAttendanceId(workAttendanceId);
        if (fillAttendance0 !=null){
            fillAttendance0.setContent(content);
            fillAttendance0.setStatus("0");
            fillAttendance0.setUpdateTime(new Date());
            fillAttendanceDAO.update(fillAttendance0);
            if (StringUtils.isNotBlank(photoFile)) {
                FillAttendanceFiles fillAttendanceFiles = fillAttendanceFilesDAO.findByFillAttendanceId(fillAttendance0.getId());
                if (fillAttendanceFiles != null){
                    fillAttendanceFiles.setFileUrl(photoFile);
                    fillAttendanceFiles.setUpdateTime(new Date());
                    fillAttendanceFilesDAO.update(fillAttendanceFiles);
                }else {
                    FillAttendanceFiles fillAttendanceFiles1 = new FillAttendanceFiles();
                    fillAttendanceFiles1.setId(UUID.randomUUID().toString());
                    fillAttendanceFiles1.setFillAttendanceId(fillAttendance0.getId());
                    fillAttendanceFiles1.setFileUrl(photoFile);
                    fillAttendanceFiles1.setCreateTime(new Date());
                    fillAttendanceFiles1.setDelFlag(false);
                    fillAttendanceFilesDAO.insert(fillAttendanceFiles1);
                }
//                fillAttendanceFiles.setFillAttendanceId(fillAttendance.getId());
//                fillAttendanceFiles.setFileUrl(photoFile);
//                fillAttendanceFiles.setCreateTime(new Date());
//                fillAttendanceFiles.setDelFlag(false);
//                fillAttendanceFilesDAO.insert(fillAttendanceFiles);
            }

            return fillAttendance0;


        }else {
            FillAttendance fillAttendance = new FillAttendance();
            fillAttendance.setId(UUID.randomUUID().toString());
            fillAttendance.setPersonId(personId);
            fillAttendance.setContent(content);
            fillAttendance.setType(type);
            fillAttendance.setFillDay(workAttendanceDate);
            fillAttendance.setFillAttendanceTime(workAttendanceTime);

            fillAttendance.setApprovalPersonId(Long.valueOf(approvalPersonId));
            fillAttendance.setStatus("0");
            fillAttendance.setBusinessWorkAttendanceId(workAttendanceId);
            String approvalNo = com.jpsoft.smart.modules.common.utils.StringUtils.getApprovalNo();
            fillAttendance.setApprovalNo(approvalNo);
            fillAttendance.setCreateTime(new Date());
            fillAttendance.setDelFlag(false);
            fillAttendanceDAO.insert(fillAttendance);
            if (StringUtils.isNotBlank(photoFile)) {
                FillAttendanceFiles fillAttendanceFiles = new FillAttendanceFiles();
                fillAttendanceFiles.setId(UUID.randomUUID().toString());
                fillAttendanceFiles.setFillAttendanceId(fillAttendance.getId());
                fillAttendanceFiles.setFileUrl(photoFile);
                fillAttendanceFiles.setCreateTime(new Date());
                fillAttendanceFiles.setDelFlag(false);
                fillAttendanceFilesDAO.insert(fillAttendanceFiles);
            }
            return fillAttendance;
        }







    }

    @Override
    public void updateAndWorkAtten(PersonInfo personInfo, String content, FillAttendance fillAttendance) {
        fillAttendance.setStatus("1");
        fillAttendance.setApprovalContent(content);
        fillAttendance.setUpdateTime(new Date());
        fillAttendance.setUpdateBy(personInfo.getName());
        fillAttendance.setApprovalTime(new Date());
        fillAttendanceDAO.update(fillAttendance);

        WorkAttendance workAttendance = workAttendanceDAO.get(fillAttendance.getBusinessWorkAttendanceId());
        if (workAttendance.getResult().equals("0")){
            workAttendance.setResult("1");
            workAttendanceDAO.update(workAttendance);

        }

    }

    @Override
    public FillAttendance findByBusinessWorkAttendanceId(String businessWorkAttendanceId) {
        return fillAttendanceDAO.findByBusinessWorkAttendanceId(businessWorkAttendanceId);
    }


}