package com.jpsoft.smart.config;

import org.springframework.amqp.core.Binding;
import org.springframework.amqp.core.BindingBuilder;
import org.springframework.amqp.core.DirectExchange;
import org.springframework.amqp.core.Queue;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;

@Configuration
public class RabbitmqConfig {
    @Bean
    public Queue importImageQueue() {
        return new Queue("importImageQueue",true);  //true 是否持久
    }

    @Bean
    public Queue syncWorkerAttendenceQueue() {
        return new Queue("syncWorkerAttendenceQueue",true);  //true 是否持久
    }

    @Bean
    DirectExchange importImageExchange() {
        return new DirectExchange("importImageExchange");
    }

    @Bean
    Binding bindingImportImageDirect() {
        return BindingBuilder.bind(importImageQueue()).to(importImageExchange()).with("importImage");
    }

    @Bean
    Binding bindingSyncWorkerAttendenceDirect() {
        return BindingBuilder.bind(syncWorkerAttendenceQueue()).to(importImageExchange()).with("syncWorkerAttendence");
    }
}
