package com.jpsoft.smart;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.alibaba.fastjson.serializer.SerializeConfig;
import com.jpsoft.smart.modules.business.entity.WorkAttendance;
import com.jpsoft.smart.modules.common.utils.AESUtil;
import com.jpsoft.smart.modules.realname.dto.CorpDTO;
import com.jpsoft.smart.modules.realname.dto.ProjectDTO;
import com.jpsoft.smart.modules.realname.dto.TeamDTO;
import com.jpsoft.smart.modules.realname.dto.WorkerAttendanceDTO;
import com.jpsoft.smart.modules.realname.http.RealnameSysRequest;
import com.sun.corba.se.spi.orbutil.threadpool.Work;
import io.jsonwebtoken.impl.crypto.MacProvider;
import org.apache.http.client.entity.UrlEncodedFormEntity;
import org.apache.http.client.methods.CloseableHttpResponse;
import org.apache.http.client.methods.HttpPost;
import org.apache.http.impl.client.CloseableHttpClient;
import org.apache.http.impl.client.HttpClients;
import org.apache.http.message.BasicNameValuePair;
import org.apache.http.util.EntityUtils;
import org.joda.time.DateTime;
import org.junit.Before;
import org.junit.Test;

import javax.crypto.Cipher;
import javax.crypto.spec.SecretKeySpec;
import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.io.Reader;
import java.io.UnsupportedEncodingException;
import java.math.BigDecimal;
import java.net.HttpURLConnection;
import java.net.URL;
import java.net.URLEncoder;
import java.security.MessageDigest;
import java.security.NoSuchAlgorithmException;
import java.util.*;

public class OpenAPITest {
    private final String UPLOAD_URl = "http://jztest.e2r.cn:8115/foreign/upload/check";
    private final String SELECT_URL = "http://jztest.e2r.cn:8115/foreign/select/check";
    private final String APP_ID = "yOtqoojmsmz";
    private final String APP_SECRET = "534a33e888b001a246b635b76e42d0dd";

    private RealnameSysRequest request;

    @Before
    public void init(){
        request = new RealnameSysRequest();
    }

    @Test
    public void projectAddTest(){
        ProjectDTO dto = new ProjectDTO();
        dto.setName("沙北碧桂园");
        dto.setAddress("湖北省");
        dto.setContractPrice(new BigDecimal(80000));
        dto.setDepartmentIndustryId("68");
        dto.setDistrictCCode("421002");
        dto.setDistrictCode("421002");
        dto.setEndTime("859");
        dto.setGcProcess("1");
        dto.setLatLng("114.225446,30.560052");
        dto.setMoneySource("130");
        dto.setProjectDesc("");
        dto.setProjectType("117");
        dto.setStartTime("2018-11-02");

        List<ProjectDTO> dtoList = new ArrayList<>();

        dtoList.add(dto);

        SerializeConfig config = new SerializeConfig();

        String jsonStr = JSONObject.toJSONString(dtoList, config);

        JSONObject response = request.sendPost(APP_ID,APP_SECRET, UPLOAD_URl,"Project.Add",jsonStr);

        System.out.println(response.getString("mesage"));

        //1575542056612
    }

    @Test
    public void projectSelTest(){
        Map<String,Object> map = new HashMap<>();
        map.put("PROJECTCODE","1575542056612");

//        List<Map> dtoList = new ArrayList<>();
//        dtoList.add(map);

        String jsonStr = JSONObject.toJSONString(map);

        JSONObject response = request.sendPost(APP_ID,APP_SECRET,SELECT_URL,"Project.Sel",jsonStr);

        System.out.println(response.getString("data"));
    }

    @Test
    public void CorpUploadTest(){
        CorpDTO corpDTO = new CorpDTO();
        corpDTO.setSocialCreditCode("91120222797261880N");
        corpDTO.setCompanyType(2);
        corpDTO.setName("建筑公司1");
        corpDTO.setRegisteredArea("421002");
        corpDTO.setLegalPerson("郑强");
        corpDTO.setLegalPersonPhone("13986703087");
        corpDTO.setProjectLeader("小刚1");
        corpDTO.setProjectLeaderPhone("13986703088");
        corpDTO.setProjectManager("小刚2");
        corpDTO.setProjectManagerPhone("13986703089");
        corpDTO.setLaborLeader("小刚3");
        corpDTO.setLaborLeaderPhone("13986703090");
        corpDTO.setDesposit(new BigDecimal(100));
        corpDTO.setRegisterDate("2020-06-01");


        List<CorpDTO> dtoList = new ArrayList<>();
        dtoList.add(corpDTO);

        String jsonStr = JSONObject.toJSONString(dtoList);
        JSONObject response = request.sendPost(APP_ID,APP_SECRET,UPLOAD_URl,"Corp.Upload",jsonStr);

        System.out.println(response.getString("data"));
    }

    @Test
    public void CorpSelTest(){
        Map<String,Object> map = new HashMap<>();
        map.put("PROJECTCODE","1575542056612");
        map.put("COMPANYTYPE","1"); //查施工单位:2报错

        String jsonStr = JSONObject.toJSONString(map);

        JSONObject response = request.sendPost(APP_ID,APP_SECRET,SELECT_URL,"Corp.Sel",jsonStr);

        System.out.println(response.getString("data"));
    }

    /**
     * 参建单位查询
     */
    @Test
    public void ProjectSubContractorSelTest(){
        Map<String,Object> map = new HashMap<>();
        map.put("PROJECTCODE","1575542056612");
//        map.put("NAME","1");
        map.put("PAGE","1");
        map.put("ROWS","10");

        String jsonStr = JSONObject.toJSONString(map);

        JSONObject response = request.sendPost(APP_ID,APP_SECRET,SELECT_URL,"ProjectSubContractor.Sel",jsonStr);

        System.out.println(response.getString("data"));
    }

    @Test
    public void TeamAddTest(){
        TeamDTO teamDTO = new TeamDTO();

        teamDTO.setProjectCode("1575542056612");
        teamDTO.setSocialCreditCode("91120222797261880N");
        teamDTO.setMonitorName("测试班组");
        teamDTO.setName("测试");
        teamDTO.setPhone("13986703087");
//        teamDTO.setIdNumber(AESUtil.encrypt("421002198311131816",APP_SECRET));
        teamDTO.setIdNumber("zMfvL9dX4Dl4sdT7oDDSgBAxqba/j8mykWZ+oUgFeQA=");

        teamDTO.setAddress("荆州");
        teamDTO.setStartTime("2020-06-01");

        List<TeamDTO> dtoList = new ArrayList<>();
        dtoList.add(teamDTO);

        String jsonStr = JSONObject.toJSONString(dtoList);

        JSONObject response = request.sendPost(APP_ID,APP_SECRET,UPLOAD_URl,"Team.Add",jsonStr);

        //BZ1591004812994
        System.out.println(response.getString("data"));
    }

    @Test
    public void TeamSelTest(){
        Map<String,Object> map = new HashMap<>();
        map.put("PROJECTCODE","1575542056612");
        map.put("MONITORNAME","泥工班组");
        map.put("PAGE",1);
        map.put("ROWS",10);

//      List<Map> dtoList = new ArrayList<>();
//      dtoList.add(map);

        String jsonStr = JSONObject.toJSONString(map);

        JSONObject response = request.sendPost(APP_ID,APP_SECRET,SELECT_URL,"Team.Sel",jsonStr);

        System.out.println(response.getString("data"));
    }

    @Test
    public void ProjectWorkerSel(){
        Map<String,Object> map = new HashMap<>();
        map.put("PROJECTCODE","1575542056612");
//        map.put("NAME","陈永洪");
        map.put("IDNUMBER","421002198311131816");
//        map.put("WORKCLASSES","1575542056612");
        map.put("PAGE",1);
        map.put("ROWS",10);

//      List<Map> dtoList = new ArrayList<>();
//      dtoList.add(map);

        String jsonStr = JSONObject.toJSONString(map);

        JSONObject response = request.sendPost(APP_ID,APP_SECRET,SELECT_URL,"ProjectWorker.Sel",jsonStr);

        System.out.println(response.getString("data"));
        JSONArray jsonArray = response.getJSONObject("data").getJSONArray("data");

        if(jsonArray.size()>0){
            jsonArray.getJSONObject(0).getString("contracttype");
        }
    }

    @Test
    public void WorkerAttendanceAdd(){
        WorkerAttendanceDTO dto = new WorkerAttendanceDTO();

        dto.setProjectCode("1575542056612");
        dto.setIdNumber(AESUtil.encrypt("421002198311131816",APP_SECRET));
//      dto.setTeamSysNo("BZ1591004812994");

        //参建单位 914205007446360609,但实际显示记录是当前用户关联的参建单位，这里只验证社会统一信用证是否存在
        dto.setSocialCreditCode("914205007446360609");
        dto.setContractType("ZD42100220200602015498");
        dto.setStartTime(DateTime.now().toString("yyy-MM-dd HH:mm:ss"));
        dto.setSignDate(DateTime.now().toString("yyy-MM-dd"));

        List<WorkerAttendanceDTO> dtoList = new ArrayList<>();
        dtoList.add(dto);
        String jsonStr = JSONObject.toJSONString(dtoList);

        JSONObject response = request.sendPost(APP_ID,APP_SECRET,UPLOAD_URl,"WorkerAttendance.Add",jsonStr);

        System.out.println(response.getString("data"));
    }


    @Test
    public void WorkerAttendanceSel(){
        Map<String,Object> map = new HashMap<>();
        map.put("PROJECTCODE","1575542056612");
        map.put("NAME","杨所");
        map.put("PAGE",1);
        map.put("ROWS",10);

        String jsonStr = JSONObject.toJSONString(map);
        JSONObject response = request.sendPost(APP_ID,APP_SECRET,SELECT_URL,"WorkerAttendance.Sel",jsonStr);

        System.out.println(response.getString("data"));
    }
}
